### 1.4.4
Fixed: Wrong user permissions due to wrong dataContainer loading in contao default dca popup fields
Fixed: Pass the correct template data to the deprecated layout template

### 1.4.3
Fixed: Correct reference to original id for backend wildcard in multiple included elements (#251)
Update: Avoid breaking the initialize chain: Change the order in config.php to load user objects before any database objects

### 1.4.2
Fixed: The active record object should not contain the customTpl value to avoid overriding the default template for contao elements (#249)
Added: TemplateAttribute->picture() to use like $this->field('myImage')->picture('picture_default'); (#248)

### 1.4.1
Update: Support Contao image sizes in tl_pct_customelement_attribute.size
Update: Do not check if Export plugin runs in config.php. Avoids a php error (blank page) in the install tool

### 1.4.0
Fixed: Handle contaos default fields in editAll and overrideAll mode correctly in combination with CE fields (#244)
Added: Export plugin in core
Update: Import is based on templates now
Update: Show the blank Option checkbox for IncludeElement Attributes

### 1.3.4
Fixed: number_format field must be deserialized in Number attribute
Fixed: Display values in wildcard for include elements (#235)
Fixed: Bypass the contao methods in the Include Element Attribute if include item is null or 0 to avoid a foreach error in tl_content class
Update: $GLOBALS['PCT_CUSTOMELEMENTS']['fieldnamesSharedWithContao'] to avoid unwanted overwrites with contao fields
Update: Show tl_pct_customelement_attribute.eval_tl_class_m12 in Checkbox attributes

### 1.3.3
Fixed: Duplicating a root page including its child pages causes php error (#229)
Fixed: Double check if an entry already exists in the vault before setting the default value (#230)
Update: Store the processed field uuids only when the widget is being processed

### 1.3.2
Fixed: Check return value of processWildcardValue hook before overwriting current value (#227)
Fixed: Register the initializeSystem Hook for loading assets not for the install tool

### 1.3.1
Fixed: Return the attribute value if it has beed marked as modified
Added: Optional rgxp for url Attributes
Update: Remove the hardcoded rgxp for url Attributes

### 1.3.0
Fixed: Do not return the value modified from outside for option values (#210)
Fixed: Contao standard fields do not show up in editAll mode (#212)
Fixed: Attribute Image: use default image size when size option field is empty
Fixed: Reordering groups had no effect on the widget (#215)
Fixed: New attributes in duplicated groups had same field name as parent attribute (#219)
Added: The default contao headline field in tl_content and tl_module
Added: Support the customTpl field in contao 3.4
Added: CustomElementFactory::fetch, fetchById(), fetchByAlias()
Added: Translate labels and descriptions via langconfig or dcaconfig (#213)
Added: [loadValue] Hook
Added: Support for translated option values (#218)
Update: Removed the separation between ce_ and mod_ templates to use a global layout template (#204)
Update: Allow custom templates in CustomElement::render($objTemplate) method
Update: Generate the alias with underscores (#211)
Update: Attribute Headline: Check if field has a readable value
Update: Improved the DCA handling, CE should be loaded on first position always
Removed: Default headline field (#217)

### 1.2.9
Fixed: Php foreach error when a just created CE-widget contains a group with no attributes or no attributes published (#202)
Fixed: Authenticate the current user in the config.php before initializing
Fixed: Support Included CustomElements via ContentAlias ContentElement (#204)
Fixed: Wrong option for the lightbox attribute in Attribute Url
Added: prepareRendering Hook as an alternative way to render any attribute
Added: Supscript text in attribute listview with information about the contao class (w50 clr long) (#205)
Added: fetchByAlias() in AttributeFactory class
Added: Create an origin object for the backend wildcard callback
Added: ImportChain Hook to add tables to the general import array
Update: Changed the input type for tl_pct_customelement_attribute.option to checkboxWizard
Update: Improved the modified handling in Attributes class (#203)
Update: Added the element ID and table to the processWildcard Hook
Update: tl_pct_customelement_attribute.template has now chosen=true
Update: Handle generic wizards and make the widget more accessible
Update: Use the loadOptionValues method in Attribute Url
Update: Use the placeholer ###CUSTOMELEMENT_WIDGET### in the palette string to inject the widget at any position
Update: Validate timestamp attributes
Update: Attribute templates now use the Core\FrontendTemplate class
Update: Provide more helpful template functions for the attribute templates
Update: Removed the error logs in AttributeFactory

### 1.2.8
Fixed: New value from processWildcardValue HOOK kept unrecognized (#200)

### 1.2.7
Fixed: [options] field in AttributeTimestamp must be deserialized
Fixed: Solved an issue when calling the PluginsLoader via the initializeSystem hook
Fixed: TinyMCE did not load custom formats under Contao 3.4 (#194)
Fixed: Avoid wrong palette builds by just appending the default palette
Added: tl_templates, tl_theme, tl_style_sheet ,tl_layout, tl_image_size to restricted tables
Added: Backend descriptions for attributes (#196)
Added: More function in DcaHelper to handle palettes
Added: Display a backend hint if plugin requires a higher/differenz CustomElements Version
Added: AttributeFactory::fetchMultipleById, fetchMultiplePublishedById
Added: Full support for customelements in revolutionsliders: create copies in vault and so on...
Added: Select in systemsettings to load font-awesome from local space or cdn (#197)
Added: DcaHelper->removePalette([string]), DcaHelper->removePalettes([array])
Added: Origin::getTable()
Update: Natural order for attribute type list
Update: Empty values will not be processed in the wildcard
Update: Load fontawesome via CDN (#197)
Update: New language arrays for the attribute labels (#198)
Update: Support the tinyMCE in Contao 3.3
Update: DcaHelper generatePalettes does not need an array anymore

### 1.2.6
Fixed: Load value again from vault if image value is not a valid binary type (#190)
Fixed: processWildcardHook triggers an php error when value is empty (#182)
Fixed: getImage in AttributeImage::processWildcardValue expects a valid path string
Fixed: Load and save correct values in editAll mode
Added: Models classes for contao 3.4 (#180)
Update: Pass origin object to the attribute being rendered
Update: Load the dca in popups only for the field requested by the user when field name is given
Update: Convert binary data to uuids in values() method in TemplateAttribute class

### 1.2.5
Fixed: Fields rendered to often in editAll mode (#177)
Fixed: Fallback for image attribute values, using the old contao 2 SRC Format (#178)
Fixed: Creating copies in tl_calendar_events (#179)
Update: Contao 3.4 compatibility updates

### 1.2.4
Fixed: Return the base attribute in template when calling an alias with a zero counter e.g. $this->field('fax#0') returns $this->field('fax') (#172)
Fixed: Generate a new uuid for new attributes in duplicated groups to make them unique (#171)
Fixed: Handle copies from root pages (#174)
Added: setOptionValues method for Attributes to allow manipulations on the generic options fields from outside

### 1.2.3
Fix: Rendering images in backend wildcard (#165)
Added: editAll and overrideAll mode for CustomElement fields (#167)
Added: $GLOBALS['PCT_CUSTOMELEMENTS']['saveValuesInWizard'] (true/false) to toggle whether to store the attribute values in the wizard data or not
Added: Maintenance section and update job
Added: WizardUpdater job to update wizard datas to latest structure
Added: AttributeUpdater job to update / convert vault data from one vault column to the default or a custom data column
Update: FE Performance Kit #3, minimize sql queries (#162)
Update: Remove arrFieldDef parameter from renderAttribute Callbacks
Update: Values and arrData values will not be pre-deserialized (#166)
 
### 1.2.2
Fixed: Merge with existing DCA arrays in addFields method, check if dca array has been created
Fixed: Store lists (AttributeList) as blob (#161)
Added: Minlength, maxlength evaluation (#155)
Added: Handle load_ and save_callbacks for attributes (#156)
Added: AttributeNumber for numeric values (#157)
Update: Font-Awesome 4.2
Update: Remove __construct method in attributes that do not overwrite default settings (#158)
Update: More performance and general updates

### 1.2.1
Fixed: Wrong variable name in DcaHelper->addSubpalette() and create selector array if it does not exist
Fixed: Load options values correctly in AttributeUrl
Fixed: Missing values in duplicated attributes (#153)
Added: addFields(), addField() method in DcaHelper class

### 1.2.0
Fixed: AttributeFactory::findMultipleByCustomElement returns array of attribute objects
Added: TemplateAttribute class for more convenient and oop-based template structure (#137)
Added: Handle options from attributes: added ::optionvalue, ::option method to retrieve option values from attributes (#139)
Added: Updater Helper class for managing all methods related to updating CE data (#147)
Added: PluginsLoader class
Update: Do not create an attribute object in the vault for fetching data. Use the options array instead (#138)
Update: storeValueHook: Pass the attribute id to the hook and generate the attribute only when accessing the hook
Update: Updated customelement_layout_xxx templates to object structure
Update: Store the customelement version with the wizard/widget data
Update: Store processed values in TemplateAttribute class for futher use (#140)
Update: More performance updates and bug fixes
Update: Write log only when displaying errors is enabled (#144)
Update: Use initializeSystem Hook for loading attributes and plugins instead of loading from the config.php file (#148)
Update: Load dca files in ::loadAll method when tables has been asigned to the attribute or plugin (#149)

### 1.1.10.1
Fixed: GroupFactory::byWizard method moved to CustomElementFactory class
Update: Handle LIKE queries and percentage values in query strings with sprintf (#132)

### 1.1.10
Fixed: Fatal error when deleting files from tl_files (#127)
Fixed: Avoid parseBackendTemplate Hook in contao installation
Added: Store processed CustomElements in a cache array
Added: Debug mode and processing time measurement and inserttags for the output
Update: Reuse once created CE objects in ContentCustomElement, ModuleCustomElement class
Update: Do not generate the attribute template before the renderCallback (might lead to double generation)
Update: Attribute::renderCallback is an alternative to the normal template->parse()
Update: Removed the strBuffer parameter from the renderCallback
Update: Build the associated field array without a new foreach loop (#126)
Update: Remove firephp call in CustomElements.php
Update: Increase internal counter on custom where clauses in QueryBuilder
Update: Add missing optional query options array to functions in AttributeFactory

### 1.1.9.1
Fixed: Do not call parseBackendTemplate when running the install tool (#123)
Update: Use require instead of require_once in AttributeLoader class (#122)

### 1.1.9
Added: English language files (#116)
Added: 'loadCustomElementFields' ajax/post flag to force CE to load the fields in the current DCA (#114)
Added: General toggle visibility method for any table (#112)
Update: Merge field definition array with attributes from dca array (#113)
Update: Build DCA from arrays (#96)
Update: Use ajax to toggle the visibilty of attributes in group view (#112)
Update: Reverse #113: Do not merge attributes field def. array (#120)

### 1.1.8
Update: Move import files to cto_layout/ce_templates (#108)
Update: Natural sorting by title for import options (#110)

### 1.1.7.1
Fixed: Toggle groups correctly when session is empty

### 1.1.7
Fixed: Filter empty values from query parts before building the where clause in QueryBuilder
Fixed: Wrong variable name in QueryBuilder (#90)
Fixed: Use CE title as fallback in list view (#93) (hotfix)
Fixed: The groups closed by default option didn't work (#103)
Fixed: Added parent id (pid) parameter for locating attributes in vault. fixes unwanted removals from source element (#104)
Added: Default value for text attributes (#81)
Added: Support FIND_IN_SET operations in QueryBuilder ()
Added: Font-Awesome library GPL (http://fortawesome.github.io/Font-Awesome/license/)
Added: Backend-Icon support (#70)
Added: Plugins can be excluded from customelements (#92)
Added: Versionnumber in list view (#94)
Added: Contao ajax loading box (#99)
Update: Remove the doNotCopy flag to keep the published setting for groups and attributes on copy (#79)
Update: Create pseudo activeRecord object via boolean parameter in Attribute::getActiveRecord(true) (#83)
Update: Allow to chose the include element in CE not just in the attribute settings (#82)
Update: Do not process empty values in sql statements (#87)
Update: Allow custom where conditions and empty value query arrays in QueryBuilder (#88)
Update: Combine sql query arrays correctly in QueryBuilder::combine

### 1.1.6.2
Update: Return on empty attribute.id values (#84)

### 1.1.6.1
Fixed: Do not fetch sorting column in tl_module

### 1.1.6
Fixed: Duplicating groups without saving might cause wrong group indexes and uplicate attribute uuids (#62)
Fixed: Duplicating/copying elements with CEs now use unique keys for the clipboard array (#64)
Fixed: Save field values only when contao backend form has been submitted (#74)
Added: Full support for News module (#64)
Added: Full support for Calendar module (#66)
Added: New Class Callbacks (contains all custom methods called by hooks)
Added: New hooks: createCopyInVault, observeClipboard, removeFromVault (see Core\Hooks.php)
Added: Handle sortable field types e.g. the Files attribute (#54)
Added: Migration from old wizard data to new wizard data when old data has been found
Update: Groups now have a unique identifyer in the widget to avoid interferences between existing groups and groups just created
Update: Attributes clones (uuids of the generic copies) now stored in the widget data in the database
Update: Improved approach and performance enhancements when dublicating elements (#64)
Update: New widget template with data-id, data-count, data-copy information for each group
Update: CustomElements.js supports new data-XXX structure in groups
Update: Write Copy number next group title in widget (#67)
Update: Associated arrays now use the fix copy number as the alias index (#75)
Update: Associated arrays back to indexes based on sorting (#76)

### Version 1.1.5
Fixed: Validating mandatory fields did not show error in backend (#32)
Fixed: Load tl_content clas via loadDataContainer in AttributeInclude\TableCustomElementAttribte (#40)
Fixed: Duplicating articles without admin rights resolves in an error message (#43)
Fixed: Rendercallback bypasses attribute templates. (#50)
Fixed: Default size in AttributeImage has been ignored when at least one option value was set (#51)
Fixed: Correct dca handling for shared fields like (tl_pct_customelement_attribute.options)
Fixed: Wildcard rendering for AttributeTable
Added: Rgxp for attribute [text] (#31)
Added: AttributeTimestamp
Added: AttributeTable
Added: AllowHtml Option for attributes (text,headline) (#41)
Update: Forcing to load the dca fields only in popup or for filetree widgets (#35)
Update: Create a registry array with field definitions when generating each Attribute (widget) (#35)
Update: Pass more variables to _attr template (#49)
Update: DatePicker compatibility for Contao 3.3 (#52)
Update: AttributeList (#46)
Update: processWildcardValue Hook (#57)
Update: Minor bug fixes

### Version 1.1.4 (2014-05-23)
Fixed: A javascript issue with the TinyMCE 4 in Contao 3.3

### Version 1.1.3 (2014-05-13)
Fixed: Wrong class name in AttributeInclude/dca/tl_pct_customelement_attribute
Added: Support for new TinyMCE4 in Contao 3.3
Update: General bug fixes and enhancements

### Version 1.1.2 (2014-04-26)
Update: More flexible code structure in QueryBuilder class and added count method

### Version 1.1.1 (2014-04-24)
Fixed: Added missing dca files in attribute folders

### Version 1.1 (2014-04-24)
Update: Mayor update. CE is now ready for plugin CustomCatalog (CC)
Update: Introduced QueryBuilder Class to manage database operations
Update: All Factory Class use the QueryBuilder to do their database operations
Update: More stability updates and fixes

### Version 1.0.1 (2014-04-24)
Fixed: Using static methods to load language files in dca files (#16)
Fixed: CE missing palettes or displaying wrong palettes when internal cache is active (#16)
Fixed: Switching palettes to select might cause php error for inputType OptionWizard (#17)
Fixed: AttributeIncluded missing in autoload.php
Update: Added changelog.txt file
Update: Minor changes